$ErrorActionPreference = 'Stop';

# Define URLs and checksums for each platform
$packageArgsX86 = @{
    packageName    = 'WiresockVpnGateway'
    fileType       = 'msi'
    url            = 'https://www.wiresock.net/sdc_download/922/?key=hyilnmwdwh37yp3knckqrn5r53z081'
    checksum       = '1167006CD1650547801FAF1ABF3B0A8382B2EFF27B61BCA042E67B959AE2F9E6'
    checksumType   = 'sha256' # or another checksum type (e.g., sha256)
    silentArgs     = '/qn'
    validExitCodes = @(0, 3010, 1641)
}

$packageArgsX64 = @{
    packageName    = 'WiresockVpnGateway'
    fileType       = 'msi'
    url            = 'https://www.wiresock.net/sdc_download/921/?key=bekfpuvidq5x8ofg2u74j2lqk8zy9y'
    checksum       = 'CE9A67BDBA012EB9EDFBEB090BAF76DE29DF7680F14C9BF032757D642D9E8D1F'
    checksumType   = 'sha256' # or another checksum type (e.g., sha256)
    silentArgs     = '/qn'
    validExitCodes = @(0, 3010, 1641)
}

$packageArgsARM64 = @{
    packageName    = 'WiresockVpnGateway'
    fileType       = 'msi'
    url            = 'https://www.wiresock.net/sdc_download/923/?key=7m03u7cp7axlt2jhf62bc186gnx0s3'
    checksum       = 'B83CE6BBFA72898BF821309C5546F30F1583974AD5CA105CDCBF25C108576E37'
    checksumType   = 'sha256' # or another checksum type (e.g., sha256)
    silentArgs     = '/qn'
    validExitCodes = @(0, 3010, 1641)
}

# Detect platform
if ([System.Environment]::Is64BitOperatingSystem -and (Get-WmiObject Win32_Processor).AddressWidth -eq 64) {
    $isARM64 = $false
    try {
        $isARM64 = (Get-WmiObject Win32_ComputerSystem).SystemType -like "*ARM64*"
    } catch {
        # Fallback if the WMI query fails
        $isARM64 = $false
    }
    
    if ($isARM64) {
        $packageArgs = $packageArgsARM64
    } else {
        $packageArgs = $packageArgsX64
    }
} else {
    $packageArgs = $packageArgsX86
}

# Install the package
Install-ChocolateyPackage @packageArgs
